"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findAssociatedInscriptionPda = void 0;
const serializers_1 = require("@metaplex-foundation/umi/serializers");
function findAssociatedInscriptionPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplInscription', '1NSCRfGeyo7wPUazGbaPBUsTM49e1k2aXewHGARfzSo');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('Inscription'),
        (0, serializers_1.string)({ size: 'variable' }).serialize('Association'),
        (0, serializers_1.string)({ size: 'variable' }).serialize(seeds.associated_tag),
        (0, serializers_1.publicKey)().serialize(seeds.inscriptionMetadataAccount),
    ]);
}
exports.findAssociatedInscriptionPda = findAssociatedInscriptionPda;
//# sourceMappingURL=associatedInscription.js.map