"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchInscriptionMetadataFromSeeds = exports.fetchInscriptionMetadataFromSeeds = exports.findInscriptionMetadataPda = exports.getInscriptionMetadataGpaBuilder = exports.safeFetchAllInscriptionMetadata = exports.fetchAllInscriptionMetadata = exports.safeFetchInscriptionMetadata = exports.fetchInscriptionMetadata = exports.deserializeInscriptionMetadata = exports.getInscriptionMetadataAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getInscriptionMetadataAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['inscriptionAccount', (0, serializers_1.publicKey)()],
        ['bump', (0, serializers_1.u8)()],
        ['dataType', (0, types_1.getDataTypeSerializer)()],
        ['inscriptionRank', (0, serializers_1.u64)()],
        ['inscriptionBump', (0, serializers_1.option)((0, serializers_1.u8)())],
        ['updateAuthorities', (0, serializers_1.array)((0, serializers_1.publicKey)())],
        ['associatedInscriptions', (0, serializers_1.array)((0, types_1.getAssociatedInscriptionSerializer)())],
        ['mint', (0, serializers_1.option)((0, serializers_1.publicKey)())],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 7 })],
    ], { description: 'InscriptionMetadataAccountData' });
}
exports.getInscriptionMetadataAccountDataSerializer = getInscriptionMetadataAccountDataSerializer;
function deserializeInscriptionMetadata(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getInscriptionMetadataAccountDataSerializer());
}
exports.deserializeInscriptionMetadata = deserializeInscriptionMetadata;
async function fetchInscriptionMetadata(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'InscriptionMetadata');
    return deserializeInscriptionMetadata(maybeAccount);
}
exports.fetchInscriptionMetadata = fetchInscriptionMetadata;
async function safeFetchInscriptionMetadata(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists
        ? deserializeInscriptionMetadata(maybeAccount)
        : null;
}
exports.safeFetchInscriptionMetadata = safeFetchInscriptionMetadata;
async function fetchAllInscriptionMetadata(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'InscriptionMetadata');
        return deserializeInscriptionMetadata(maybeAccount);
    });
}
exports.fetchAllInscriptionMetadata = fetchAllInscriptionMetadata;
async function safeFetchAllInscriptionMetadata(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeInscriptionMetadata(maybeAccount));
}
exports.safeFetchAllInscriptionMetadata = safeFetchAllInscriptionMetadata;
function getInscriptionMetadataGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplInscription', '1NSCRfGeyo7wPUazGbaPBUsTM49e1k2aXewHGARfzSo');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        inscriptionAccount: [1, (0, serializers_1.publicKey)()],
        bump: [33, (0, serializers_1.u8)()],
        dataType: [34, (0, types_1.getDataTypeSerializer)()],
        inscriptionRank: [35, (0, serializers_1.u64)()],
        inscriptionBump: [43, (0, serializers_1.option)((0, serializers_1.u8)())],
        updateAuthorities: [null, (0, serializers_1.array)((0, serializers_1.publicKey)())],
        associatedInscriptions: [
            null,
            (0, serializers_1.array)((0, types_1.getAssociatedInscriptionSerializer)()),
        ],
        mint: [null, (0, serializers_1.option)((0, serializers_1.publicKey)())],
        padding: [null, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 7 })],
    })
        .deserializeUsing((account) => deserializeInscriptionMetadata(account));
}
exports.getInscriptionMetadataGpaBuilder = getInscriptionMetadataGpaBuilder;
function findInscriptionMetadataPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplInscription', '1NSCRfGeyo7wPUazGbaPBUsTM49e1k2aXewHGARfzSo');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('Inscription'),
        (0, serializers_1.publicKey)().serialize(programId),
        (0, serializers_1.publicKey)().serialize(seeds.inscriptionAccount),
    ]);
}
exports.findInscriptionMetadataPda = findInscriptionMetadataPda;
async function fetchInscriptionMetadataFromSeeds(context, seeds, options) {
    return fetchInscriptionMetadata(context, findInscriptionMetadataPda(context, seeds), options);
}
exports.fetchInscriptionMetadataFromSeeds = fetchInscriptionMetadataFromSeeds;
async function safeFetchInscriptionMetadataFromSeeds(context, seeds, options) {
    return safeFetchInscriptionMetadata(context, findInscriptionMetadataPda(context, seeds), options);
}
exports.safeFetchInscriptionMetadataFromSeeds = safeFetchInscriptionMetadataFromSeeds;
//# sourceMappingURL=inscriptionMetadata.js.map