"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchInscriptionShardFromSeeds = exports.fetchInscriptionShardFromSeeds = exports.findInscriptionShardPda = exports.getInscriptionShardSize = exports.getInscriptionShardGpaBuilder = exports.safeFetchAllInscriptionShard = exports.fetchAllInscriptionShard = exports.safeFetchInscriptionShard = exports.fetchInscriptionShard = exports.deserializeInscriptionShard = exports.getInscriptionShardAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getInscriptionShardAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['shardNumber', (0, serializers_1.u8)()],
        ['count', (0, serializers_1.u64)()],
    ], { description: 'InscriptionShardAccountData' });
}
exports.getInscriptionShardAccountDataSerializer = getInscriptionShardAccountDataSerializer;
function deserializeInscriptionShard(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getInscriptionShardAccountDataSerializer());
}
exports.deserializeInscriptionShard = deserializeInscriptionShard;
async function fetchInscriptionShard(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'InscriptionShard');
    return deserializeInscriptionShard(maybeAccount);
}
exports.fetchInscriptionShard = fetchInscriptionShard;
async function safeFetchInscriptionShard(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeInscriptionShard(maybeAccount) : null;
}
exports.safeFetchInscriptionShard = safeFetchInscriptionShard;
async function fetchAllInscriptionShard(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'InscriptionShard');
        return deserializeInscriptionShard(maybeAccount);
    });
}
exports.fetchAllInscriptionShard = fetchAllInscriptionShard;
async function safeFetchAllInscriptionShard(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeInscriptionShard(maybeAccount));
}
exports.safeFetchAllInscriptionShard = safeFetchAllInscriptionShard;
function getInscriptionShardGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplInscription', '1NSCRfGeyo7wPUazGbaPBUsTM49e1k2aXewHGARfzSo');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        shardNumber: [2, (0, serializers_1.u8)()],
        count: [3, (0, serializers_1.u64)()],
    })
        .deserializeUsing((account) => deserializeInscriptionShard(account));
}
exports.getInscriptionShardGpaBuilder = getInscriptionShardGpaBuilder;
function getInscriptionShardSize() {
    return 11;
}
exports.getInscriptionShardSize = getInscriptionShardSize;
function findInscriptionShardPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplInscription', '1NSCRfGeyo7wPUazGbaPBUsTM49e1k2aXewHGARfzSo');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('Inscription'),
        (0, serializers_1.string)({ size: 'variable' }).serialize('Shard'),
        (0, serializers_1.publicKey)().serialize(programId),
        (0, serializers_1.u8)().serialize(seeds.shardNumber),
    ]);
}
exports.findInscriptionShardPda = findInscriptionShardPda;
async function fetchInscriptionShardFromSeeds(context, seeds, options) {
    return fetchInscriptionShard(context, findInscriptionShardPda(context, seeds), options);
}
exports.fetchInscriptionShardFromSeeds = fetchInscriptionShardFromSeeds;
async function safeFetchInscriptionShardFromSeeds(context, seeds, options) {
    return safeFetchInscriptionShard(context, findInscriptionShardPda(context, seeds), options);
}
exports.safeFetchInscriptionShardFromSeeds = safeFetchInscriptionShardFromSeeds;
//# sourceMappingURL=inscriptionShard.js.map