/**
 * This code eclipses the initialize function in clients/js/src/generated/instructions/initialize.ts.
 * It is used to hide the shard retrieval logic from the user, and instead randomly select a shard.
 */
import { Context, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type InitializeInstructionAccounts = {
    /** The account to store the metadata in. */
    inscriptionAccount: Signer;
    /** The account to store the inscription account's metadata in. */
    inscriptionMetadataAccount?: PublicKey | Pda;
    /** The shard account for the inscription counter. */
    inscriptionShardAccount?: PublicKey | Pda;
    /** The account that will pay for the transaction and rent. */
    payer?: Signer;
    /** The authority of the inscription account. */
    authority?: Signer;
    /** System program */
    systemProgram?: PublicKey | Pda;
};
export type InitializeInstructionData = {
    discriminator: number;
};
export type InitializeInstructionDataArgs = {
    /** The number of the shard to use. */
    shard?: number;
};
export declare function initialize(context: Pick<Context, 'eddsa' | 'payer' | 'programs'>, input: InitializeInstructionAccounts & InitializeInstructionDataArgs): TransactionBuilder;
