"use strict";
/**
 * This code eclipses the initialize function in clients/js/src/generated/instructions/initialize.ts.
 * It is used to hide the shard retrieval logic from the user, and instead randomly select a shard.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialize = void 0;
const initialize_1 = require("./generated/instructions/initialize");
const generated_1 = require("./generated");
// Instruction.
function initialize(context, input) {
    let inscriptionShardAccount;
    if (input.inscriptionShardAccount) {
        inscriptionShardAccount = input.inscriptionShardAccount;
    }
    else {
        let shardNumber;
        if (input.shard) {
            shardNumber = input.shard;
        }
        else {
            shardNumber = Math.floor(Math.random() * 32);
        }
        inscriptionShardAccount = (0, generated_1.findInscriptionShardPda)(context, { shardNumber });
    }
    return (0, initialize_1.initialize)(context, { inscriptionShardAccount, ...input });
}
exports.initialize = initialize;
//# sourceMappingURL=initialize.js.map