/**
 * This code eclipses the initializeFromMint function in clients/js/src/generated/instructions/initializeFromMint.ts.
 * It is used to hide the shard retrieval logic from the user, and instead randomly select a shard.
 */
import { Context, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
export type InitializeFromMintInstructionAccounts = {
    /** The account to store the metadata in. */
    mintInscriptionAccount?: PublicKey | Pda;
    /** The account to store the inscription account's metadata in. */
    inscriptionMetadataAccount?: PublicKey | Pda;
    /** The mint that will be used to derive the PDA. */
    mintAccount: PublicKey | Pda;
    /** The metadata for the mint. */
    tokenMetadataAccount?: PublicKey | Pda;
    /** The shard account for the inscription counter. */
    inscriptionShardAccount?: PublicKey | Pda;
    /** The account that will pay for the transaction and rent. */
    payer?: Signer;
    /** The authority of the inscription account. */
    authority?: Signer;
    /** System program */
    systemProgram?: PublicKey | Pda;
};
export type InitializeFromMintInstructionData = {
    discriminator: number;
};
export type InitializeFromMintInstructionDataArgs = {
    /** The number of the shard to use. */
    shard?: number;
};
export declare function initializeFromMint(context: Pick<Context, 'eddsa' | 'payer' | 'programs'>, input: InitializeFromMintInstructionAccounts & InitializeFromMintInstructionDataArgs): TransactionBuilder;
