"use strict";
/**
 * This code eclipses the initializeFromMint function in clients/js/src/generated/instructions/initializeFromMint.ts.
 * It is used to hide the shard retrieval logic from the user, and instead randomly select a shard.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeFromMint = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const initializeFromMint_1 = require("./generated/instructions/initializeFromMint");
const generated_1 = require("./generated");
// Instruction.
function initializeFromMint(context, input) {
    let inscriptionAccount;
    if (input.mintInscriptionAccount) {
        inscriptionAccount = input.mintInscriptionAccount;
    }
    else {
        inscriptionAccount = (0, generated_1.findMintInscriptionPda)(context, {
            mint: (0, umi_1.publicKey)(input.mintAccount),
        });
    }
    let inscriptionMetadataAccount;
    if (input.inscriptionMetadataAccount) {
        inscriptionMetadataAccount = input.inscriptionMetadataAccount;
    }
    else {
        inscriptionMetadataAccount = (0, generated_1.findInscriptionMetadataPda)(context, {
            inscriptionAccount: (0, umi_1.publicKey)(inscriptionAccount),
        });
    }
    let inscriptionShardAccount;
    if (input.inscriptionShardAccount) {
        inscriptionShardAccount = input.inscriptionShardAccount;
    }
    else {
        let shardNumber;
        if (input.shard) {
            shardNumber = input.shard;
        }
        else {
            shardNumber = Math.floor(Math.random() * 32);
        }
        inscriptionShardAccount = (0, generated_1.findInscriptionShardPda)(context, { shardNumber });
    }
    return (0, initializeFromMint_1.initializeFromMint)(context, {
        mintInscriptionAccount: inscriptionAccount,
        inscriptionMetadataAccount,
        mintAccount: input.mintAccount,
        tokenMetadataAccount: input.tokenMetadataAccount,
        inscriptionShardAccount,
        payer: input.payer,
        authority: input.authority,
        systemProgram: input.systemProgram,
    });
}
exports.initializeFromMint = initializeFromMint;
//# sourceMappingURL=initializeFromMint.js.map